﻿using DinerContracts.BindingModels;
using DinerContracts.ViewModels;
using DinerContracts.SearchModels;

namespace DinerContracts.BusinessLogicsContracts
{
    public interface IReportLogic
    {
        List<ReportSnackComponentViewModel> GetSnackComponents();
        List<ReportOrdersViewModel> GetOrders(ReportBindingModel model);
        List<ReportShopsViewModel> GetShops();
        List<ReportGroupOrdersViewModel> GetGroupedOrders();
        void SaveSnacksToWordFile(ReportBindingModel model);
        void SaveSnackComponentToExcelFile(ReportBindingModel model);
        void SaveOrdersToPdfFile(ReportBindingModel model);
        void SaveShopsToWordFile(ReportBindingModel model);
        void SaveShopsToExcelFile(ReportBindingModel model);
        void SaveGroupedOrdersToPdfFile(ReportBindingModel model);
    }
}
